# All Music Guide music scrpaer
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):


    i = string.find(source, "bb_pr_category")

    if i != -1:
        mtype = stripText(source[i:])
        mtype = searchForPlus(mtype, "\"")
        i = string.find(mtype, "\"")
        mtype = stripText(mtype[0:i])

        if mtype == "classical_music":
            amgClassical(source)
            return


    # Main Extraction (Rock)
    # Find Artist
    tag = "class=\"album-artist\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"release-artist\""
        i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, "<span itemprop=\"name\">")
        artist = stripText(artist)

        if artist.startswith("<a href=") == 1:
            artist = searchForPlus(artist, "\">")

        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        artist = cleanup(artist)
        aw.setArtist(artist)


    # Find Title
    tag = "class=\"release-title\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"album-title\""
        i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        title = cleanup(title)
        aw.setTitle(title)


    # Find Image
    tag = "class=\"album-cover\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"release-cover\""
        i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        i = string.find(image, "</div>")
        image = stripText(image[0:i])

        i = string.find(image, " src=\"")

        if i != -1:
            image = searchForPlus(image, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "/JPG_400/")

            if i != -1:
                image = string.replace(image, "/JPG_400/", "/JPG_250/")

            aw.setImage1(image)

            image = string.replace(image, "/JPG_250/", "/JPG_500/")
            aw.setLargeImage1(image)


    # Find Rating
    i = string.find(source, "class=\"allmusic-rating")

    if i != -1:
        rating = searchForPlus(source, "class=\"allmusic-rating")
        rating = searchForPlus(rating, "itemprop=\"ratingValue\">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        aw.setMyRating(rating)


    # Find Date
    i = string.find(source, "class=\"release-date\">")

    if i != -1:
        date = searchForPlus(source, "class=\"release-date\">")
        date = searchForPlus(date, "<span>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)
        aw.setCopyrightDate(date)


    # Find Running Time
    i = string.find(source, "class=\"duration\">")

    if i != -1:
        time = searchForPlus(source, "class=\"duration\">")
        time = searchForPlus(time, "<span>")
        i = string.find(time, "<")
        aw.setRunningTime(stripText(time[0:i]))


    # Find Category
    i = string.find(source, "class=\"genre\"")

    if i != -1:
        category = searchForPlus(source, "class=\"genre\"")
        category = searchForPlus(category, "<div>")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        aw.setCategory1(stripText(category[0:i]))


    # Find Keywords (Styes)
    i = string.find(source, "class=\"styles\"")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, "class=\"styles\"")
        temp = searchForPlus(temp, "<div>")
        i = string.find(temp, "</div>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "<a href=\"") != None):
            temp = searchForPlus(temp, "<a href=\"")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")

            if keywords == "":
                keywords = stripText(temp[0:i])
            else:
                keywords = keywords + ", " + stripText(temp[0:i])

        aw.setKeywords(keywords)


    # Find AMG ID
    i = string.find(source, "class=\"metadata-ids\"")

    if i != -1:
        amgid = searchForPlus(source, "class=\"metadata-ids\"")

        if string.find(amgid, "AMG Pop ID") != -1:
            amgid = searchForPlus(amgid, "AMG Pop ID")
            amgid = searchForPlus(amgid, "<span>")
            i = string.find(amgid, "<")
            aw.setExternalID(stripText(amgid[0:i]))

        if string.find(amgid, "AMG Classical ID") != -1:
            amgid = searchForPlus(amgid, "AMG Classical ID")
            amgid = searchForPlus(amgid, "<span>")
            i = string.find(amgid, "<")
            aw.setExternalID(stripText(amgid[0:i]))


    # Find Comments
    i = string.find(source, "class=\"review read-more\"")

    if i != -1:
        comment = searchForPlus(source, "class=\"review read-more\"")
        comment = searchForPlus(comment, "\">")

        i = string.find(comment, "class=\"review-author headline\">")

        if i != -1:
            comment = searchForPlus(comment, "class=\"review-author headline\">")
            i = string.find(comment, "</h3>")
            comments = stripText(comment[0:i])
        else:
            i = string.find(comment, "</div")
            comments = stripText(comment[0:i])

        comment = searchForPlus(comment, "class=\"text\"")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "</section>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

        comments = cleanup(comments)
        aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "class=\"track-listing\"")

    if i != -1:
        disks = searchForPlus(source, "class=\"track-listing\"")
        i = string.find(disks, "</section>")
        disks = stripText(disks[0:i])
        diskNum = 0
        diskTag = "class=\"disc\""

        while (searchFor(disks, diskTag) != None):
            diskNum = diskNum + 1
            disks = searchForPlus(disks, diskTag)
            tracks = disks
            i = string.find(tracks, "</table>")
            tracks = stripText(tracks[0:i])

            trackNum = 0
            trackTag = "<tr class=\"track"

            while (searchFor(tracks, trackTag) != None):
                trackNum = trackNum + 1

                tracks = searchForPlus(tracks, trackTag)
                i = string.find(tracks, "</tr>")
                track = stripText(tracks[0:i])

                title = searchForPlus(track, "class=\"title\"")
                title = searchForPlus(title, ">")
                title = searchForPlus(title, "\">")
                i = string.find(title, "<")
                title = stripText(title[0:i])

                songwriter = ""
                i = string.find(track, "class=\"composer\"")

                if i != -1:
                    writers = searchForPlus(track, "class=\"composer\"")
                    i = string.find(writers, "</td>")
                    writers = stripText(writers[0:i])

                    while (searchFor(writers, "href=") != None):
                        writers = searchForPlus(writers, "href=")
                        writers = searchForPlus(writers, "\">")
                        i = string.find(writers, "<")

                        if songwriter == "":
                            songwriter = stripText(writers[0:i])
                        else:
                            songwriter = songwriter + " / " + stripText(writers[0:i])

                artist = ""
                i = string.find(track, "class=\"primary\"")

                if i != -1:
                    artist = searchForPlus(track, "class=\"primary\"")
                    artist = searchForPlus(artist, "\">")
                    i = string.find(artist, "<")
                    artist = stripText(artist[0:i])

                time = ""
                i = string.find(track, "class=\"time\"")

                if i != -1:
                    time = searchForPlus(track, "class=\"time\"")
                    time = searchForPlus(time, ">")
                    i = string.find(time, "<")
                    time = stripText(time[0:i])

                aw.setTrack(diskNum, trackNum, title, songwriter=songwriter, artist=artist, time=time)



    # Find Copyright Date
    i = string.find(source, "Name=\"RLS\"")

    if (i != -1):
        source = searchForPlus(source, "Name=\"RLS\"")
        source = searchForPlus(source, "WIDTH=71>")
        i = string.find(source, "<")
        aw.setCopyrightDate(stripText(source[0:i]))





def amgClassical(source):
    i = string.find(source, "<!--Start Content Area -->")

    if i == -1:
        return


    # Main Extraction (Rock)
    source = searchForPlus(source, "<!--Start Content Area -->")

    # Find Title
    source = searchForPlus(source, "<span class=\"title\">")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Image
    i = string.find(source, "image.allmusic.com")

    if (i != -1):
        source = source[i-25:]
        source = searchForPlus(source, " src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])


    i = string.find(source, "id=\"left-sidebar-title\"")

    if i != -1:
        # Find Artist
        i = string.find(source, ">Featured Artist<")

        if i != -1:
            source = searchForPlus(source, ">Featured Artist<")
            source = searchForPlus(source, "class=\"sub-text\"")
            source = searchForPlus(source, "\">")
            i = string.find(source, "<")
            artist = stripText(source[0:i])
            artist = convertArtist(artist)


        # Find Date
        i = string.find(source, ">Release Date<")

        if i != -1:
            source = searchForPlus(source, ">Release Date<")
            date = searchForPlus(source, "class=\"sub-text\"")
            date = searchForPlus(date, ">")
            i = string.find(date, "<")
            date = stripText(date[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])

            copyDate = date


        # Find Running Time
        i = string.find(source, ">Time<")

        if i != -1:
            # Might have hit Track header
            if i < 1000:
                source = searchForPlus(source, ">Time<")
                source = searchForPlus(source, "class=\"sub-text\"")
                source = searchForPlus(source, "class=\"sub-text\"")
                source = searchForPlus(source, ">")
                i = string.find(source, "<")
                running = stripText(source[0:i])


        # Find Label
        i = string.find(source, ">Label<")

        if i != -1:
            source = searchForPlus(source, ">Label<")
            source = searchForPlus(source, "class=\"sub-text\"")
            source = searchForPlus(source, ">")
            i = string.find(source, "<")
            label = stripText(source[0:i])
            i = string.find(label, "[")

            if i != -1:
                label = stripText(label[0:i])


        # Find Category
        i = string.find(source, ">Genre<")

        if (i != -1):
            source = searchForPlus(source, ">Genre<")
            source = searchForPlus(source, "class=\"sub-text\"")
            source = searchForPlus(source, ">")
            i = string.find(source, "<")
            category = stripText(source[0:i])


        # Find Keywords (Styes)
        i = string.find(source, "<!--Styles Listing-->")

        if i != -1:
            keywords = ""
            temp = searchForPlus(source, "<!--Styles Listing-->")
            i = string.find(temp, "<!--End Genre/Styles-->")
            temp = stripText(temp[0:i])

            while (searchFor(temp, "<a href=\"") != None):
                temp = searchForPlus(temp, "<a href=\"")
                temp = searchForPlus(temp, "\">")
                i = string.find(temp, "<")

                if keywords == "":
                    keywords = stripText(temp[0:i])
                else:
                    keywords = keywords + ", " + stripText(temp[0:i])


    # Find Comments
    i = string.find(source, "class=\"title\">Review<")

    if (i != -1):
        comments = "Review"
        source = searchForPlus(source, "class=\"title\">Review<")
        i = string.find(source, "</td></tr></table>")
        tempcomment = source[0:i]

        i = string.find(tempcomment, "class=\"author\"")

        if i != -1:
            tempcomment = searchForPlus(tempcomment, "class=\"author\"")   
            tempcomment = searchForPlus(tempcomment, ">")   
            i = string.find(tempcomment, "<")
            comments = comments + " " + stripText(tempcomment[0:i])
            comments = string.replace(comments, "  ", " ")

        i = string.find(tempcomment, ">Read More...<")

        if i != -1:
            tempcomment = searchForPlus(tempcomment, "... <a href=\"")   
            i = string.find(tempcomment, "\">")
            tempcomment = "http://www.allmusic.com" + tempcomment[0:i]
            tempcomment = string.replace(tempcomment, "&amp;", "&")
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            tempcomment = http.getContents(tempcomment, "UTF-8")

            try:
                t2 = open(aw.getLogsDir() + "trace2.html", "w")
                t2.write(tempcomment)
                t2.close()
            except:
                print "Unable to create trace2.html"

            tempcomment = searchForPlus(tempcomment, "class=\"title\">Review<")
            i = string.find(tempcomment, "</td></tr></table>")
            tempcomment = tempcomment[0:i]

            i = string.find(tempcomment, "class=\"author\"")

            if i != -1:
                tempcomment = searchForPlus(tempcomment, "class=\"author\"")   
                tempcomment = searchForPlus(tempcomment, ">")   
            

        i = string.find(tempcomment, "</td><tr></table>")

        if i != -1:
            tempcomment = tempcomment[0:i]

        tempcomment = searchForPlus(tempcomment, "<td ")   
        tempcomment = searchForPlus(tempcomment, "\">")   

        tempcomment = string.replace(tempcomment, "</a>", "")
        tempcomment = string.replace(tempcomment, "</A>", "")
        tempcomment = string.replace(tempcomment, "<p>", "\n\n")
        tempcomment = string.replace(tempcomment, "<P>", "\n\n")
        tempcomment = string.replace(tempcomment, "</p>", "")
        tempcomment = string.replace(tempcomment, "<BR>", "\n")
        tempcomment = string.replace(tempcomment, "<br>", "\n")
        tempcomment = string.replace(tempcomment, "<br />", "\n")
        tempcomment = string.replace(tempcomment, "<i>", "")
        tempcomment = string.replace(tempcomment, "</i>", "")
        tempcomment = string.replace(tempcomment, "<I>", "")
        tempcomment = string.replace(tempcomment, "</I>", "")
        tempcomment = string.replace(tempcomment, "<b>", "")
        tempcomment = string.replace(tempcomment, "</b>", "")
        tempcomment = string.replace(tempcomment, "</font>", "")
        tempcomment = string.replace(tempcomment, "</span>", "")
        tempcomment = string.replace(tempcomment, "&copy;", "")
        tempcomment = string.replace(tempcomment, "&#169;", "")
        tempcomment = string.replace(tempcomment, "&#8217;", "'")
        tempcomment = string.replace(tempcomment, "&quot;", "\"")
        tempcomment = string.replace(tempcomment, "&#8211;", "-")

        while (searchFor(tempcomment, "<a ") != None):
            i = string.find(tempcomment, "<a ")
            j = string.find(tempcomment[i:], ">")
            tempcomment = tempcomment[0:i] + tempcomment[i+j+1:]

        while (searchFor(tempcomment, "<A ") != None):
            i = string.find(tempcomment, "<A ")
            j = string.find(tempcomment[i:], ">")
            tempcomment = tempcomment[0:i] + tempcomment[i+j+1:]

        while (searchFor(tempcomment, "<img src") != None):
            i = string.find(tempcomment, "<img src")
            j = string.find(tempcomment[i:], ">")
            tempcomment = tempcomment[0:i] + tempcomment[i+j+1:]

        while (searchFor(tempcomment, "<span") != None):
            i = string.find(tempcomment, "<span")
            j = string.find(tempcomment[i:], ">")
            tempcomment = tempcomment[0:i] + tempcomment[i+j+1:]

        while (searchFor(tempcomment, "<font color=") != None):
            i = string.find(tempcomment, "<font color=")
            j = string.find(tempcomment[i:], ">")
            tempcomment = tempcomment[0:i] + tempcomment[i+j+1:]

        comments = comments + "\n\n" + stripText(tempcomment)



    # Find Tracks
    i = string.find(source, "<!--Begin Performances List-->")

    if i != -1:
        trackList = []
        artistList = []
        writerList = []
        timeList = []
        pcol = 0
        wcol = 0

        source = searchForPlus(source, "<!--Begin Performances List-->")

        i = string.find(source, "<!--End Performances List-->")
        tracks = stripText(source[0:i])
        trackIndex = 1

        while (searchFor(tracks, "class=\"cell\"") != None):
            trackIndex = trackIndex + 1
            trackid = "%02d" % trackIndex

            # Composer
            tracks = searchForPlus(tracks, "class=\"cell\"")
            tracks = searchForPlus(tracks, "\">")
            i = string.find(tracks, "<")
            writer = stripText(tracks[0:i])
            writerList.append("01-" + trackid + "-" + stripText(writer))

            # Listen icon
            tracks = searchForPlus(tracks, "class=\"cell\"")

            # Title
            tracks = searchForPlus(tracks, "class=\"cell\"")
            tracks = searchForPlus(tracks, "\">")
            i = string.find(tracks, "</td>")
            track = stripText(tracks[0:i])

            while (searchFor(track, "<a ") != None):
                i = string.find(track, "<a ")
                j = string.find(track[i:], ">")
                track = track[0:i] + track[i+j+1:]

            track = string.replace(track, "</a>", "")

            while (searchFor(track, "<span ") != None):
                i = string.find(track, "<span ")
                j = string.find(track[i:], ">")
                track = track[0:i] + track[i+j+1:]

            track = string.replace(track, "</span>", "")

            track = string.replace(track, "[*]", "")
            track = string.replace(track, "<i>", "")
            track = string.replace(track, "</i>", "")

            trackList.append("01-" + trackid + "-" + stripText(track))

            # Year
            tracks = searchForPlus(tracks, "class=\"cell\"")
            tracks = searchForPlus(tracks, ">")
            i = string.find(tracks, "<")
            year = stripText(tracks[0:i])

            # Time
            tracks = searchForPlus(tracks, "class=\"cell\"")
            tracks = searchForPlus(tracks, ">")
            i = string.find(tracks, "<")
            time = stripText(tracks[0:i])
            timeList.append("01-" + trackid + "-" + stripText(time))

            # Artist
            artistList.append("01-" + trackid + "-")


        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)
        writerList.sort()
        trackWriters = array(writerList, String)
        timeList.sort()
        trackTimes = array(timeList, String)



    # Find Copyright Date
    i = string.find(source, "Name=\"RLS\"")

    if (i != -1):
        source = searchForPlus(source, "Name=\"RLS\"")
        source = searchForPlus(source, "WIDTH=71>")
        i = string.find(source, "<")
        copyDate = stripText(source[0:i])



def cleanup(comment):
    # Fixed in 3.22
    comment = string.replace(comment, "\xC3\xA1", "")
    comment = string.replace(comment, "\xC3\xA3", "")
    comment = string.replace(comment, "\xC3\xA7", "")
    comment = string.replace(comment, "\xC3\xAA", "")
    comment = string.replace(comment, "\xC3\xB3", "")
    comment = string.replace(comment, "\xC3\xB4", "")
    comment = string.replace(comment, "\xC3\xBA", "")
    comment = string.replace(comment, "\xCC\xA3", "")
    comment = string.replace(comment, "\xCC\xA4", "")
    comment = string.replace(comment, "\xCC\xA9", "")
    comment = string.replace(comment, "\xCC\xAB", "")
    comment = string.replace(comment, "\xCC\xC1", "")
    return comment


try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
