# bol.com [NL] music scraper
#
# Copyright  1999-2013 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("")


    # Find Image
    imageTag = "class=\"product-images"
    i = string.find(source, imageTag)

    if i != -1:
        image = searchForPlus(source, "class=\"product-images")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image[i:].startswith("xxx") == 1:
            image = ""
        else:
            aw.setImage1(image)

        image = searchForPlus(source, "class=\"product-images")
        image = searchForPlus(image, " data-zoom-src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image != "":
            if image[i:].startswith("xxx") == 1:
                image = ""
            else:
                aw.setLargeImage1(image)


    # Find Title
    source = searchForPlus(source, "name=\"product_title\"")
    source = searchForPlus(source, "<h1 class=")
    source = searchForPlus(source, "\" >")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)


    # Find Artist
    i = string.find(source, "Artiest")

    if i != -1:
        artist = searchForPlus(source, "Artiest")
        artist = searchForPlus(artist, "href")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        artist = fixChar(artist)
        aw.setArtist(artist)


    # Find List Price
    i = string.find(source, "class=\"fleft boxedtop_xs\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"fleft boxedtop_xs\"")
        listprice = searchForPlus(listprice, " ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        aw.setListPrice(listprice)


    # Find Price
    i = string.find(source, "class=\"offer_price\"")

    if i != -1:
        value = searchForPlus(source, "class=\"offer_price\"")
        value = searchForPlus(value, "</span>")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(source, "class=\"offer_price_fraction\"")

        if i != -1:
            fraction = searchForPlus(source, "class=\"offer_price_fraction\"")
            fraction = searchForPlus(fraction, ">")
            i = string.find(fraction, "<")
            value = value + stripText(fraction[0:i])
            aw.setItemValue(value)

            aw.setPurchasePrice(aw.getItemValue())
            aw.setPurchaseDate(Date())
            aw.setPurchasePlace(aw.getSource())


    # Find Comments
    i = string.find(source, ">Productbeschrijving<")

    if i != -1:
        comments = searchFor(source, ">Productbeschrijving<")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        comments = fixChar(comments)

        i = string.find(comments, "Tracklist<")

        if i != -1:
            comments = stripText(comments[0:i])

        aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, ">Tracklist<")

    if i != -1:
        disks = searchForPlus(source, ">Tracklist<")
        i = string.find(disks, "</div>")
        disks = stripText(disks[0:i])

        if string.find(disks, "Disk\x0A") == -1:
            disks = "Disk\x0A1" + disks

        diskCount = 0

        while (searchFor(disks, "Disk\x0A") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "Disk\x0A")

            i = string.find(disks, "</p>")
            tracks = stripText(disks[0:i])
            trackIndex = 0

            while (searchFor(tracks, "\"track__title\"") != None):
                tracks = searchForPlus(tracks, "\"track__title\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])
                trackIndex = trackIndex + 1

                bonus = "false"
                i = string.find(title, "(Bonustrack)")

                if i != -1:
                    title = stripText(title[0:i])
                    bonus = "true"

                artist = ""
                i = string.find(title, " No Artist Extraction ")

                if i != -1:
                    artist = stripText(title[i+3:])
                    title = stripText(title[0:i])

                aw.setTrack(diskCount, trackIndex, title, artist=artist,  bonus=bonus)


    # Find Label
    i = string.find(source, "Uitgever")

    if i != -1:
        label = searchForPlus(source, "Uitgever")
        label = searchForPlus(label, "href")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Format
    i = string.find(source, "Uitvoering")

    if i != -1:
        label = searchForPlus(source, "Uitvoering")
        label = searchForPlus(label, "class=\"specs__value\"")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        i = string.find(label, "Cd (album)")

        if i != -1:
            aw.setFormat("CD")


    # Find Release date
    i = string.find(source, "Releasedatum")

    if i != -1:
        date = searchForPlus(source, "Releasedatum")
        date = searchForPlus(date, "class=\"specs__value\"")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find UPC
    i = string.find(source, "EAN")

    if i != -1:
        upc = searchForPlus(source, "EAN")
        upc = searchForPlus(upc, "class=\"specs__value\"")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Category
    i = string.find(source, "Categorie&euml;n")

    if i != -1:
        cats = searchForPlus(source, "Categorie&euml;n")
        cats = searchForPlus(source, "Categorie&euml;n")
        cats = searchForPlus(cats, "class=\"specs__value\"")
        cats = searchForPlus(cats, ">")
        i = string.find(cats, "</dd>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if ccount == 1:
                aw.setCategory1(cat)
            elif ccount == 2:
                aw.setCategory2(cat)
            else:
                aw.setCategory3(cat)
                break

            ccount = ccount + 1






def fixChar(source):
    source =  string.replace(source, "\xC3\xA5", "")
    source =  string.replace(source, "\xC3\xAB", "")
    source =  string.replace(source, "\xC3\xB8", "")
    return source



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
