# CDDB scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):

    # Find Image
    i = string.find(source, "class=\"album-image\">")

    if i != -1:
        source = searchForPlus(source, "class=\"album-image\">")
        source = searchForPlus(source, "<img src=\"")
        i = string.find(source, "\"")
        image = "http://www.gracenote.com" + stripText(source[0:i])

        i = string.find(image, "default_cover")

        if i == -1:
            aw.setImage1(image)


    # Find Title
    i = string.find(source, "<strong>Album</strong>")

    if (i != -1):
        source = searchForPlus(source, "<strong>Album</strong>")
        source = searchForPlus(source, " > ")
        i = string.find(source, "<")
        aw.setTitle(stripText(source[0:i]))


    # Find Artist
    i = string.find(source, "class=\"artist-name\"")

    if i != -1:
        source = searchForPlus(source, "class=\"artist-name\"")
        source = searchForPlus(source, "href=")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        aw.setArtist(stripText(source[0:i]))


    # Find Copyright date
    i = string.find(source, "<strong>Year of Release</strong>")

    if i != -1:
        source = searchForPlus(source, "<strong>Year of Release</strong>")
        source = searchForPlus(source, " > ")
        i = string.find(source, "<")
        aw.setCopyrightDate(stripText(source[0:i]))


    # Find Label
    i = string.find(source, "<strong>Label</strong>")

    if (i != -1):
        source = searchForPlus(source, "<strong>Label</strong>")
        source = searchForPlus(source, " > ")
        i = string.find(source, "<")
        aw.setLabel(stripText(source[0:i]))


    # Find Tracks
    # No multi disk sets, CDDB lists CDs separately
    i = string.find(source, "class=\"track-list\"")
    diskCount = 1
    trackNum = 0

    if (i != -1):
        source = searchForPlus(source, "class=\"track-list\"")
        i = string.find(source, "class=\"footer")
        tracks = stripText(source[0:i])

        while (searchFor(tracks, "class=\"track_name\"") != None):
            trackNum = trackNum + 1
            tracks = searchForPlus(tracks, "class=\"track_name\"")
            tracks = searchForPlus(tracks, ">")
            i = string.find(tracks, "<")
            track = stripText(tracks[0:i])

            i = string.find(track, " -- ")

            if i == -1:
                i = string.find(track, " - ")

            artist = ""

            if i != -1:
                artist = stripText(track[i+3:])
                track = stripText(track[0:i])

                if artist[0:7] == "<a href":
                    artist = searchForPlus(artist, ">")
                    i = string.find(artist, "<")
                    artist = stripText(artist[0:i])

            aw.setTrack(diskCount, trackNum, track, artist=artist)




try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
