# fishpond.com.au music scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    i = string.find(source, "> - did not match any products.<")

    if i != -1:
        return

    i = string.find(source, "Products meeting the search criteria")

    if i != -1:
        return


    # Main extraction
    source = searchForPlus(source, "<!-- body_text //-->")


    # Find Title
    title = searchForPlus(source, "id=\"product_title\"")
    title = searchForPlus(title, "\">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.rfind(title, "[")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)


    # Find Artist
    i = string.find(source, "id=\"product_author\"")

    if (i != -1):
        artist = searchForPlus(source, "id=\"product_author\"")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)


    # Find Image
    tag = "class=\"product_img\""
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "dvd-no-image")

        if i == -1:
            aw.setImage1(image)


    tag = "big_img.src = '"
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        i = string.find(image, "'")
        image = stripText(image[0:i])

        i = string.find(image, "dvd-no-image")

        if i == -1:
            aw.setLargeImage1(image)


    # Find List Price
    i = string.find(source, "class=\"productOriginalPrice\"")

    if i != -1:
        value = source[i:]
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setListPrice(value)
        aw.setItemValue(value)
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Price
    i = string.find(source, "class=\"productSpecialPrice\"")

    if i != -1:
        value = source[i:]
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setItemValue(value)
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Label
    i = string.find(source, ">Label:")

    if (i != -1):
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, ">")
        label = searchForPlus(label, "<td>")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Tracks
    tag = "id=\"tracks-table\""
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        i = string.find(source, "</table>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disc 1<") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")

            i = string.find(disks, ">Disc ")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = stripText(disks)

            trackNum = 0

            tag = "id=\"trackRow_"

            while (searchFor(tracks, tag) != None):
                tracks = searchForPlus(tracks, tag)
                tracks = searchForPlus(tracks, "<td>")
                tracks = searchForPlus(tracks, "<td>")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                i = string.find(track, "RealOne")

                if i != -1:
                    break

                i = string.find(track, " - ")
                artist = ""

                if i != -1:
                    artist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                trackNum = trackNum + 1

                aw.setTrack(diskCount, trackNum, track, artist=artist)
    else:
        tag = "class=\"productListing-data\""
        i = string.find(source, tag)

        if i == -1:
            tag = "Tracks:<"
            i = string.find(source, tag)

        if i != -1:
            disks = searchForPlus(source, tag)
            i = string.find(disks, "</table>")
            disks = stripText(disks[0:i])

            i = string.find(disks, "Disc ")
            
            if i == -1:
                disks = "Disc 1:<br />" + disks;

            diskCount = 0

            while (searchFor(disks, "Disc ") != None):
                diskCount = diskCount + 1
                disks = searchForPlus(disks, "Disc ")

                i = string.find(disks, "Disc ")

                if i != -1:
                    tracks = stripText(disks[0:i])
                else:
                    tracks = stripText(disks)

                trackNum = 0

                while (searchFor(tracks, "<td class=\"productListing-data\" style=") != None):
                    tracks = searchForPlus(tracks, "<td class=\"productListing-data\" style=")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    track = stripText(tracks[0:i])

                    i = string.find(track, " - ")
                    artist = ""

                    if i != -1:
                        artist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                    trackNum = trackNum + 1

                    aw.setTrack(diskCount, trackNum, track, artist=artist)


    # Find Format
    i = string.find(source, ">Format:")

    if i != -1:
        format = searchForPlus(source, ">Format:")
        format = searchForPlus(format, "<td>")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.find(format, ";")

        if i != -1:
            aw.setSound(stripText(format[i+1:]))
            format = stripText(format[0:i])

        aw.setFormat(format)


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, "<td>")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Release Date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"description\"")

    if i != -1:
        comments = searchForPlus(source, "class=\"description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</span>")
        comments = stripText(comments[0:i])
        i = string.find(comments, "Tracks:<")

        if i != -1:
            comments = stripText(comments[0:i])

    i = string.find(source, ">Performer Notes")

    if i != -1:
        comment = searchForPlus(source, ">Performer Notes")
        comment = searchForPlus(comment, "<ul>")
        i = string.find(comment, "</ul>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    i = string.find(source, "Old-Reviews</div>")

    if i != -1:
        comment = searchForPlus(source, "Reviews</div>")
        i = string.find(comment, "<table")
        comment = "Reviews\n" + stripText(comment[0:i])
        comments = appendComment(comments, comment)

    aw.setProductInfo(comments)





try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
