# half.com audio scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    #Get detail page, if necessary
    i = string.find(source, "Search Results<")

    if i != -1:
        source = searchForPlus(source, "Search Results<")
        source = searchForPlus(source, "<A HREF=")

        # URL delimiter is somtimes single quote, sometimes
        # double quote, so use what is there
        i = string.find(source[1:], source[0:1])
        source = source[1:]
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find List price
    i = string.find(source, ">LIST PRICE<")

    if (i != -1):
        listprice = searchForPlus(source, ">LIST PRICE<")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])

        i = string.find(listprice, "(")

        if (i != -1):
            listprice = stripText(listprice[0:i])

        aw.setListPrice(listprice)


    # Find New price
    i = string.find(source, "header_items_brandNew.gif")

    if (i != -1):
        try:
            newprice = searchForPlus(source, "header_items_brandNew.gif")
            newprice = searchForPlus(newprice, "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">")
            i = string.find(newprice, "</table>")
            newprice = stripText(newprice[0:i])
            newprice = searchFor(newprice, "$")
            
            i = string.find(newprice, "<")
            
            if (i != -1):
                newprice = stripText(newprice[0:i])

            aw.setNewPrice(listprice)
        except:
            newprice = ""


    # Find Used price
    i = string.find(source, "header_items_likeNew.gif")

    if (i != -1):
        try:
            usedprice = searchForPlus(source, "header_items_likeNew.gif")
            usedprice = searchForPlus(usedprice, "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">")
            i = string.find(usedprice, "</table>")
            usedprice = stripText(usedprice[0:i])
            usedprice = searchFor(usedprice, "$")
            
            i = string.find(usedprice, "<")
            
            if (i != -1):
                usedprice = stripText(usedprice[0:i])

            aw.setUsedPrice(listprice)
        except:
            usedprice = ""


    # Find Image
    i = string.rfind(source, ".ebayimg.")

    if i != -1 and i < 50000:
        source = stripText(source[i-50:])
        source = searchForPlus(source, "<img src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "593226")

        if i == -1:
            aw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"pdppagetitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    aw.setTitle(stripText(source[0:i]))


    # Find Artist
    i = string.find(source, ">Primary Artist:")

    if i != -1:
        source = searchForPlus(source, ">Primary Artist:")
        source = searchForPlus(source, "href")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        aw.setArtist(stripText(source[0:i]))


    # Find Price
    i = string.find(source, "class=\"beststyle\"")

    if i != -1:
        source = searchForPlus(source, "class=\"beststyle\"")
        source = searchFor(source, "$")
        i = string.find(source, "<")
        aw.setItemValue(stripText(source[0:i]))
        aw.setUsedPrice(stripText(source[0:i]))

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        aw.setFormat(stripText(format[0:i]))


    # Find Publication Date
    i = string.find(source, ">Format:<")

    if i != -1:
        source = searchForPlus(source, ">Format:<")
        if string.find(source, "</span><br><span class=\"\">") < string.find(source, ">Record Label:<"):
            date = searchForPlus(source, "</span><br><span class=\"\">")
            i = string.find(date, "<")
            aw.setReleaseDate(stripText(date[0:i]))


    # Find Publisher
    i = string.find(source, ">Record Label:<")

    if (i != -1):
        label = searchForPlus(source, ">Record Label:<")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        aw.setLabel(stripText(label[0:i]))


    # Find UPC
    i = string.find(source, ">UPC:<")

    if (i != -1):
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, "\">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        upc = string.replace(upc, "-", "")
        aw.setUPC(upc)


    # Find Recording type
    i = string.find(source, ">Recording Type:")

    if (i != -1):
        rec = searchForPlus(source, ">Recording Type:")
        rec = searchForPlus(rec, "\">")
        i = string.find(rec, "<")
        aw.setRecording(stripText(rec[0:i]))


    # Find Tracks
    i = string.find(source, ">Track Listing<")

    if i != -1:
        source = searchForPlus(source, ">Track Listing<")
        i = string.find(source, "<table ")
        disks = stripText(source[0:i])

        i = string.find(disks, ">DISC 1:<")

        if i == -1:
            disks = "<br class=\"br\"/>DISC 1:" + disks

        diskCount = 0

        while (searchFor(disks, ">DISC ") != None):
            disks = searchForPlus(disks, ">DISC ")
            diskCount = diskCount + 1
            diskid = "%02d" % diskCount
            tracks = searchFor(disks, ":")
            i = string.find(tracks, ">DISC ")

            if i != -1:
                i = string.find(tracks, ">DISC ")
                tracks = stripText(tracks[0:i])

            trackNum = 0

            while (searchFor(tracks, "<br class=\"br\"/>") != None):
                tracks = searchForPlus(tracks, "<br class=\"br\"/>")
                i = string.find(tracks, ". ")

                if i == -1:
                    break

                track = searchForPlus(tracks, ". ")
                i = string.find(track, "<")
                track = stripText(track[0:i])
                trackNum = trackNum + 1

                i = string.find(track, " - ")
                artist = ""

                if i != -1:
                    if track[i+3:i+4] != "(":
                        artist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackNum, track, artist=artist)


    # Find Comments
    i = string.find(source, ">Album Notes<")

    if i != -1:
        source = searchForPlus(source, ">Album Notes<")
        source = searchForPlus(source, "class=\"br\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<table")
        aw.setProductInfo(stripText(source[0:i]))



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
