# Tower Records audio scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Check for not found
    i = string.find(source, "is not a valid Tower Records product number.")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    # Find List price
    i = string.find(source, "List Price:")

    if (i != -1):
        listprice = searchForPlus(source, "List Price:")
        listprice = searchForPlus(listprice, "\">")
        i = string.find(listprice, "<")
        aw.setListPrice(stripText(listprice[0:i]))


    # Find Image
    i = string.find(source, "<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\" style=\"width:100%\">")

    if i != -1:
        source = stripText(source[i:])
        source = searchForPlus(source, "src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "777777777")

        if i == -1:
            aw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"product_header\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if (i != -1):
        title = stripText(title[0:i])

    aw.setTitle(title)


    # Find Artist
    source = searchForPlus(source, ">By:<")
    source = stripText(searchForPlus(source, ">"))

    if source.startswith("<a href=\"") == 1:
        source = searchForPlus(source, "\">")

    i = string.find(source, "<")
    artist = stripText(source[0:i])

    i = string.find(artist, "(")

    if i != -1:
        artist = stripText(artist[0:i])

    aw.setArtist(artist)


    # Find Price
    i = string.find(source, ">Current Price:<")

    if i != -1:
        value = searchForPlus(source, ">Current Price:<")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Category
    i = string.find(source, ">Category:")

    if i != -1:
        category = searchForPlus(source, ">Category:")
        category = searchForPlus(category, "?div_id")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        aw.setCategory1(category)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Release date
    i = string.find(source, ">Release Date:")

    if (i != -1):
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find Copyright date
    i = string.find(source, ">Original release")

    if (i != -1):
        copyDate = searchForPlus(source, ">Original release")
        copyDate = searchForPlus(copyDate, ">")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        aw.setCopyrightDate(copyDate)


    # Find Label
    i = string.find(source, ">Label:")

    if (i != -1):
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Sound
    i = string.find(source, ">Stereo:")

    if (i != -1):
        sound = searchForPlus(source, ">Stereo:")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        aw.setSound(sound)


    # Find UPC
    i = string.find(source, ">UPC:")

    if i != -1:
        upc = searchForPlus(source, ">UPC:")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Tracks
    i = string.find(source, ">Track Listing<")

    if i != -1:
        source = searchForPlus(source, ">Track Listing<")
        i = string.find(source, "class=\"contener_separator\"")
        disks = stripText(source[0:i])
        diskCount = 0

        while (searchFor(disks, "\tDISC ") != None):
            disks = searchForPlus(disks, "\tDISC ")
            i = string.find(disks, " ")
            diskid = "%02d" % stripText(disks[0:i])
            i = string.find(disks, "class=\"song\"")

            if i == -1:
                tracks = disks
            else:
                tracks = stripText(disks[0:i])

            diskCount = diskCount + 1
            trackNum = 0

            while (searchFor(tracks, "class=\"songtrack\"") != None):
                tracks = searchForPlus(tracks, "class=\"songtrack\"")
                tracks = searchForPlus(tracks, "&nbsp;&nbsp;")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])
                trackNum = trackNum + 1

                artist = ""
                i = string.find(track, " - ")

                if i == -1:
                    i = string.find(track, " / ")

                if i != -1:
                    artist = stripText(track[i+3:])

                    if artist[0:1] == "(":
                        artist = ""
                    else:
                        track = stripText(track[0:i])

                if track == "":
                    continue

                # Replace until 3.04
                track = string.replace(track, "\xC3\xAD", "")
                track = string.replace(track, "\xC3\xB1", "")
                track = string.replace(track, "\xC3\xB3", "")
                aw.setTrack(diskCount, trackNum, track, artist=artist)


    # Find Comments
    comments = ""
    i = string.find(source, "<h2>Album Description</h2>")

    if (i != -1):
        source = searchForPlus(source, "<h2>Album Description</h2>")
        source = searchForPlus(source, "class=\"content\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        comments = stripText(source[0:i])
        aw.setProductInfo(comments)






try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
