# Amazon US, UK, CA  book scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string
import  time

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Australia")
    rw.setLanguage("English")
    cSymbol = "$"

    rw.setCurrencySymbol(cSymbol)


    tag = "<div class=\"fastTrack\">This item is currently not available.</div>"

    i = string.find(source, tag)

    if i != -1:
        # Amazon returning not found, try again
        source = searchForPlus(source, "\"searchKeywords\":")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        isbn = stripText(source[0:i])
        url = "http://www.amazon.com/s/ref=nb_sb_noss?url=search-alias%3Dstripbooks&field-keywords=" + isbn
        print "New url=",url
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        
        try:
            t = open(rw.getLogsDir() + "trace1a.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    tag = "class=\"listView\""

    if string.find(source, tag) == -1:
        tag = "class=\"resultCount\""

    if string.find(source, tag) == -1:
        tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, how many results
        i = string.find(source, "id=\"s-result-count\"")

        if i != -1:
            count = searchForPlus(source, "id=\"s-result-count\"")
            count = searchForPlus(count, ">")
            i = string.find(count, " ")
            count = stripText(count[0:i])

            try:
                rw.setResultCount(int(count))
            except:
                print "Unable to set result count"

        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        c = 0

        while (string.find(source, "HTTP response code: 503") != -1):
            print "Sleeping",c,"..."
            time.sleep(5)
            source = http.getContents(url)

            c = c + 1

            if c > 3:
                break
        
        try:
            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()

        except:
            print "Unable to create trace.html"

    i = string.find(source, "class=\"sans\"> Customers who viewed this item...")

    if i != -1:
        # Sometimes Amazon returns the multiple item referral page.
        # Get detail page.
        i = string.find(source, ">Read More<")
        source = stripText(source[i-200:])
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(source)
        try:
            t = open(rw.getLogsDir() + "trace.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    # Out of print
    i = string.find(source, "<span class=\"availRed\">Out of Print--Limited Availability.</span>")

    if i != -1:
        rw.setOutOfPrint("true")


    # Find Image
    tag = "id='imageBlock'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"aud_image_block\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)

    if rw.getLargeImage1() == None:
        i = string.find(source, "'imageGalleryData'")

        if i != -1:
            images = searchForPlus(source, "'imageGalleryData'")
            i = string.find(images, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setLargeImage1(image)

    if rw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchFor(images, "mainUrl\":\"")
                i = string.find(images, "}]")
                images = stripText(images[0:i])

                image = searchForPlus(images, "mainUrl\":\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                rw.setImage1(image)
                rw.setLargeImage1(image)


    if rw.getImage1() == None:
        tag = "id=\"mainImageContainer\""
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(images, "<script")
            images = stripText(images[0:i])
            images = searchFor(images, "https:")
            i = string.find(images, "&quot;")
            image = stripText(images[0:i])
            i = string.find(image, "\"")

            if i != -1:
                image = stripText(image[0:i])

            rw.setImage1(image)

            images = stripText(images[i+1:])

            i = string.find(images, "https:")

            if i != -1:
                images = searchFor(images, "https:")
                i = string.find(images, "&quot;")
                image = stripText(images[0:i])
                i = string.find(image, "\"")

                if i != -1:
                    image = stripText(image[0:i])

                rw.setLargeImage1(image)

    if rw.getImage1() == None:
        tag = "id=\"ebooksImageBlockContainer\""
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            rw.setImage1(image)

            large = string.replace(image, "_SY346_.", "")
            rw.setLargeImage1(large)


    # Find Keywords
    i = string.find(source, "name=\"field+keywords\"")

    if i != -1:
        extracted = ""
        keywords = searchFor(source, "name=\"field+keywords\"")

        while (searchFor(keywords, "name=\"field+keywords\"") != None):
            keywords = searchForPlus(keywords, "name=\"field+keywords\"")
            keywords = searchForPlus(keywords, "value=\"")
            i = string.find(keywords, "\"")
            keyword = stripText(keywords[0:i])

            if extracted == "":
                extracted = keyword
            else:
                extracted = extracted + ", " + keyword

        rw.setKeywords(extracted)


    # Find value
    value = 0
    tag = "class=\"a-color-price"

    if string.find(source, tag) == -1:
        tag = "class=\"a-size-medium a-color-price"

    i = string.find(source, tag)

    if i != -1:
        value = 1
        value = searchForPlus(source, tag)
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        rw.setItemValue(value[0:i])
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())

    if value == 0:
        i = string.find(source, ">Buy Used<")

        if i != -1:
            value = searchForPlus(source, ">Buy Used<")
            value = searchForPlus(value, cSymbol)
            i = string.find(value, "<")
            rw.setItemValue(value[0:i])
            rw.setPurchasePrice(rw.getItemValue())
            rw.setPurchaseDate(Date())
            rw.setPurchasePlace(rw.getSource())


    # Find List price
    tag = ">List Price:<"

    if string.find(source, tag) == -1:
        tag = ">RRP:<"


    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        rw.setListPrice(value[0:i])

    tt = 1

    if string.find(source, "Fiction") == -1:
        tt = 0


    # Find new/used price/count
    # Find selected edition pricing
    newPrice = 0
    usedPrice = 0
    colPrice = 0

    i = string.find(source, "a-button a-button-selected")

    if i != -1:
        prices = searchForPlus(source, "a-button a-button-selected")
        i = string.find(prices, "</li>")
        prices = stripText(prices[0:i])
        

        # Find new price/count
        i = string.find(prices, "olp-new olp-link")

        if i != -1:
            new = searchForPlus(prices, "olp-new olp-link")
            new = searchForPlus(new, "&amp;condition=new")
            new = searchForPlus(new, ">")
            new = stripText(new)
            i = string.find(new, " ")
            rw.setNewCount(new[0:i])

            if rw.getNewCount() != "0":
                new = searchForPlus(new, cSymbol)
                i = string.find(new, "<")
                rw.setNewPrice(new[0:i])
                newPrice = 1


        # Find used price/count
        i = string.find(prices, "olp-used olp-link")

        if i != -1:
            used = searchForPlus(prices, "olp-used olp-link")
            used = searchForPlus(used, "&amp;condition=used")
            used = searchForPlus(used, ">")
            used = stripText(used)
            i = string.find(used, " ")
            rw.setUsedCount(used[0:i])

            if rw.getUsedCount() != "0":
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                rw.setUsedPrice(used[0:i])
                usedPrice = 1


        # Find collectible price/count
        i = string.find(prices, "olp-collectible olp-link")

        if i != -1:
            col = searchForPlus(prices, "olp-collectible olp-link")
            col = searchForPlus(col, "&amp;condition=collectible")
            col = searchForPlus(col, ">")
            col = stripText(col)
            i = string.find(col, " ")
            rw.setCollectibleCount(col[0:i])

            if rw.getCollectibleCount() != "0":
                col = searchForPlus(col, cSymbol)
                i = string.find(col, "<")
                rw.setCollectiblePrice(col[0:i])
                colPrice = 1
    else:
        i = string.find(source, "class=\"a-tab-heading a-active mediaTab_heading\"")

        if i != -1:
            prices = searchForPlus(source, "class=\"a-tab-heading a-active mediaTab_heading\"")
            i = string.find(prices, "class=\"feature\"")

            if i == -1:
                i = string.find(prices, "id=\"submit.add-to-cart\"")

            prices = stripText(prices[0:i])

            # Find new price
            i = string.find(prices, ">Buy new<")

            if i != -1:
                new = searchForPlus(prices, ">Buy new<")
                new = searchForPlus(new, cSymbol)
                i = string.find(new, "<")
                rw.setNewPrice(new[0:i])
                newPrice = 1

            i = string.find(prices, "/ref=dp_olp_new")

            if i != -1:
                new = searchForPlus(prices, "/ref=dp_olp_new")
                new = searchForPlus(new, ">")
                i = string.find(new, " ")
                count = stripText(new[0:i])
                new = searchForPlus(new, cSymbol)
                i = string.find(new, "<")
                price = stripText(new[0:i])
                rw.setNewCount(count)
                rw.setNewPrice(price)
                newPrice = 1

            # Find used price
            i = string.find(prices, ">Buy used<")

            if i != -1:
                used = searchForPlus(prices, ">Buy used<")
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                rw.setUsedPrice(used[0:i])
                usedPrice = 1

            i = string.find(prices, "/ref=dp_olp_used?")

            if i != -1:
                used = searchForPlus(prices, "/ref=dp_olp_used")
                used = searchForPlus(used, ">")
                i = string.find(used, " ")
                count = stripText(used[0:i])
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                price = stripText(used[0:i])
                rw.setUsedCount(count)
                rw.setUsedPrice(price)
                usedPrice = 1
            else:
                i = string.find(prices, "/ref=dp_olp_used")

                if i != -1:
                    used = searchForPlus(prices, "/ref=dp_olp_used")
                    used = searchForPlus(used, ">")
                    i = string.find(used, " ")
                    count = stripText(used[0:i])
                    used = searchForPlus(used, cSymbol)
                    i = string.find(used, "<")
                    price = stripText(used[0:i])
                    rw.setUsedCount(count)
                    rw.setUsedPrice(price)
                    usedPrice = 1

            # Find collectible price
            i = string.find(prices, ">Buy collectible<")

            if i != -1:
                col = searchForPlus(prices, ">Buy collectible<")
                col = searchForPlus(col, cSymbol)
                i = string.find(col, "<")
                rw.setCollectiblePrice(col[0:i])
                colPrice = 1

            i = string.find(prices, "/ref=dp_olp_collectible")

            if i != -1:
                col = searchForPlus(prices, "/ref=dp_olp_collectible")
                col = searchForPlus(col, ">")
                i = string.find(col, " ")
                count = stripText(col[0:i])
                col = searchForPlus(col, cSymbol)
                i = string.find(col, "<")
                price = stripText(col[0:i])
                rw.setCollectibleCount(count)
                rw.setCollectiblePrice(price)
                colPrice = 1
        else:
            prices = stripText(source)

            # Find new price
            i = string.find(prices, ">Buy new<")

            if i != -1:
                new = searchForPlus(prices, ">Buy new<")
                new = searchForPlus(new, cSymbol)
                i = string.find(new, "<")
                rw.setNewPrice(new[0:i])
                newPrice = 1

            i = string.find(prices, "/ref=dp_olp_new")

            if i != -1:
                new = searchForPlus(prices, "/ref=dp_olp_new")
                new = searchForPlus(new, ">")
                i = string.find(new, " ")
                count = stripText(new[0:i])
                new = searchForPlus(new, cSymbol)
                i = string.find(new, "<")
                price = stripText(new[0:i])
                rw.setNewCount(count)
                rw.setNewPrice(price)
                newPrice = 1

            # Find used price
            i = string.find(prices, ">Buy used<")

            if i != -1:
                used = searchForPlus(prices, ">Buy used<")
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                rw.setUsedPrice(used[0:i])
                usedPrice = 1

            i = string.find(prices, "/ref=dp_olp_used")

            if i != -1:
                used = searchForPlus(prices, "/ref=dp_olp_used")
                used = searchForPlus(used, ">")
                i = string.find(used, " ")
                count = stripText(used[0:i])
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                price = stripText(used[0:i])
                rw.setUsedCount(count)
                rw.setUsedPrice(price)
                usedPrice = 1

            # Find used/new price
            i = string.find(prices, "/ref=dp_olp_all")

            if i != -1:
                used = searchForPlus(prices, "/ref=dp_olp_all")
                used = searchForPlus(used, ">")
                i = string.find(used, "&nbsp;")
                count = stripText(used[0:i])
                used = searchForPlus(used, cSymbol)
                i = string.find(used, "<")
                price = stripText(used[0:i])
                rw.setUsedCount(count)
                rw.setUsedPrice(price)
                rw.setNewCount(count)
                rw.setNewPrice(price)
                usedPrice = 1

            # Find collectible price
            i = string.find(prices, ">Buy collectible<")

            if i != -1:
                col = searchForPlus(prices, ">Buy collectible<")
                col = searchForPlus(col, cSymbol)
                i = string.find(col, "<")
                rw.setCollectiblePrice(col[0:i])
                colPrice = 1

            i = string.find(prices, "/ref=dp_olp_collectible")

            if i != -1:
                col = searchForPlus(prices, "/ref=dp_olp_collectible")
                col = searchForPlus(col, ">")
                i = string.find(col, " ")
                count = stripText(col[0:i])
                col = searchForPlus(col, cSymbol)
                i = string.find(col, "<")
                price = stripText(col[0:i])
                rw.setCollectibleCount(count)
                rw.setCollectiblePrice(price)
                colPrice = 1



    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, "roductTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if tt == 1:
        i = string.rfind(title, "(")

        if i != -1:
            title = stripText(title[0:i])

    rw.setTitle(title)

    i = string.rfind(source, ">[Kindle Edition]<")

    if i > 0 and i < 250:
        rw.setFormat("Kindle")

    # First try at formats, it somtimes follows title
    format = searchForPlus(source, "\">")
    i = string.find(format, "<")
    format = stripText(format[0:i])

    i = string.find(format, "Hardcover")

    if i != -1:
        rw.setFormat("Hardcover")

    i = string.find(format, "Paperback")

    if i != -1:
        rw.setFormat("Paperback")

    i = string.find(format, "Mass Market Paperback")

    if i != -1:
        rw.setFormat("Mass Market Paperback")

    i = string.find(format, "Perfect Paperback")

    if i != -1:
        rw.setFormat("Perfect Paperback")

    i = string.find(format, "Spiral-bound")

    if i != -1:
        rw.setFormat("Spiral-bound")

    i = string.find(format, "Leather Bound")

    if i != -1:
        rw.setFormat("Leather Bound")

    i = string.find(format, "Calendar")

    if i != -1:
        rw.setFormat("Calendar")

    i = string.find(format, "Kindle Edition")

    if i != -1:
        rw.setFormat("Kindle")

    i = string.find(format, "Audio CD")

    if i != -1:
        rw.setFormat("Audio Book")

    i = string.find(format, "MP3 CD")

    if i != -1:
        rw.setFormat("Audio Book")

    i = string.find(format, "Audio Cassette")

    if i != -1:
        rw.setFormat("Audio Book")

    i = string.find(format, "CD-ROM")

    if i != -1:
        rw.setFormat("CD-ROM")

    i = string.find(format, "DVD-ROM")

    if i != -1:
        rw.setFormat("DVD-ROM")

    i = string.find(format, "Digital")

    if i != -1:
        rw.setFormat("eBook")


    # Find rating
    i = string.find(source, "class=\"crAvgStars\"")

    if i != -1 and i <= 5000:
        rating = searchForPlus(source, "class=\"crAvgStars\"")
        rating = searchForPlus(rating, "title=\"")
        i = string.find(rating, " ")
        rw.setMyRating(rating[0:i])


    # Find Authors
    authorList = []
    tag = "id='byline'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"byline\""
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"bylineInfo\""
        i = string.find(source, tag)

    if i != -1:
        source = searchFor(source, tag)
        i = string.find(source, "<div id=")
        authors = stripText(source[0:i])

        while (searchFor(authors, "class=\"author") != None):
            authors = searchForPlus(authors, "class=\"author")

            thisAuthor = authors
            i = string.find(authors, "class=\"author")

            if i != -1:
                thisAuthor = stripText(authors[0:i])

            i = string.find(thisAuthor, "a-size-medium")

            if i != -1:
                authors = searchForPlus(authors, "a-size-medium")
            else:
                i = string.find(thisAuthor, "a-link-normal")

                if i != -1:
                    authors = searchForPlus(authors, "a-link-normal")

            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])

            if author == "these sellers":
                break

            if author == "Be the first to review this item":
                break

            i = string.find(authors, "<span class=\"a-color-secondary\">")

            if i != -1 and i < 1000:
                authors = searchForPlus(authors, "<span class=\"a-color-secondary\">")

            if authors.startswith("(") == 1:
                i = string.find(authors, ")")
                role = stripText(authors[0:i+1])

                if role == "(Author)":
                    #just use name
                    author = author
                elif role == "(Illustrator)" and rw.getIllustrator() == "":
                    rw.setIllustrator(author)
                    author = ""
                elif role == "(Translator)" and rw.getTranslator() == "":
                    rw.setTranslator(author)
                    author = ""
                elif role == "(Editor)" and rw.getEditor() == "":
                    rw.setEditor(author)
                    author = ""
                elif role == "(Author, Illustrator)" and rw.getIllustrator() == "":
                    rw.setIllustrator(author)
                else:
                    author = author + " " + role
                
            if author != "":
                authorList.append(author)

    rw.setAuthors(authorList)


    # Find Comments
    comments = ""

    tag = "data-feature-name=\"bookDescription\""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        i = string.find(reviews, "<noscript>")

        if i != -1:
            reviews = searchForPlus(reviews, "<noscript>")
            i = string.find(reviews, "</noscript>")
            comment = stripText(reviews[0:i])
            comments = appendComment(comments, comment)

    tag = "Editorial Reviews"
    header = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        header = ""

    if string.find(source, tag) != -1:
        comments = appendComment(comments, header)
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<script")

        if i != -1:
            reviews = stripText(reviews[0:i])

        i = string.find(reviews, "<a class=\"a-link-normal\"")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")

            if i != -1:
                comment = stripText(reviews[0:i])
            else:
                comment = stripText(reviews)

            i = string.find(comment, "<object")

            if i != -1:
                comment = stripText(comment[0:i])

            comments = appendComment(comments, comment)

        while (searchFor(reviews, "class=\"productDescriptionSource\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionSource\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")

            if i != -1:
                comment = stripText(reviews[0:i])
            else:
                comment = stripText(reviews)

            i = string.find(comment, "<object")

            if i != -1:
                comment = stripText(comment[0:i])

            comments = appendComment(comments, comment)

    comments =  string.replace(comments, "</DIV>", "<BR>")
    comments =  string.replace(comments, "<I >", "")
    comments =  string.replace(comments, "<b >", "<b>")
    comments =  string.replace(comments, "<i >", "<i>")
    comments =  string.replace(comments, "<o:p>", "")
    comments =  string.replace(comments, "</o:p>", "")
    comments =  string.replace(comments, "</h5>", "")
    comments =  string.replace(comments, "&#147;", "\"")
    comments =  string.replace(comments, "&#8216;", "'")
    comments =  string.replace(comments, "&#x2022;", "*")
    comments =  string.replace(comments, "&#x2015;", "-")
    comments =  string.replace(comments, "&#xE5;", "")

    comments =  string.replace(comments, "\303\245", "\345")

    rw.setProductInfo(comments)


    # Find Reading level
    i = string.find(source, ">Reading level:<")

    if i != -1:
        rlvl = searchForPlus(source, ">Reading level:<")
        rlvl = searchForPlus(rlvl, ">")
        i = string.find(rlvl, "<")
        rw.setReadingLevel(rlvl[0:i])
    else:
        i = string.find(source, ">Age Range:<")

        if i != -1:
            rlvl = searchForPlus(source, ">Age Range:<")
            rlvl = searchForPlus(rlvl, ">")
            i = string.find(rlvl, "<")
            rw.setReadingLevel(rlvl[0:i])


    # Find Lexile
    i = string.find(source, ">Lexile Measure:<")

    if i != -1:
        rlvl = searchForPlus(source, ">Lexile Measure:<")
        rlvl = searchForPlus(rlvl, ">")
        i = string.find(rlvl, "<")
        rw.setLexileLevel(rlvl[0:i])


    # Find Format
    tag = "id='formats'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"formats\""
        i = string.find(source, tag)

    if i != -1:
        format = searchForPlus(source, tag)
        i = string.find(source, "a-button-selected")

        if i != -1:
            format = searchForPlus(format, "a-button-selected")
            format = searchForPlus(format, "<span>")
            i = string.find(format, "<")
            format = stripText(format[0:i])
            rw.setFormat(format)

    if rw.getFormat() == "":
        print "NO FORMAT"
        tag = ">Product Details<"
        i = string.find(source, tag)

        if i == -1:
            tag = ">Product details<"
            i = string.find(source, tag)

        if i != -1:
            format = searchForPlus(source, tag)
            i = string.find(format, "</ul>")
            format = stripText(format[0:i])

            i = string.find(format, "Hardcover")

            if i != -1:
                rw.setFormat("Hardcover")

            i = string.find(format, "Paperback")

            if i != -1:
                rw.setFormat("Paperback")

            i = string.find(format, "Mass Market Paperback")

            if i != -1:
                rw.setFormat("Mass Market Paperback")

            i = string.find(format, "Perfect Paperback")

            if i != -1:
                rw.setFormat("Perfect Paperback")

            i = string.find(format, "Spiral-bound")

            if i != -1:
                rw.setFormat("Spiral-bound")

            i = string.find(format, "Leather Bound")

            if i != -1:
                rw.setFormat("Leather Bound")

            i = string.find(format, "Calendar")

            if i != -1:
                rw.setFormat("Calendar")

            i = string.find(format, "Kindle Edition")

            if i != -1:
                rw.setFormat("Kindle")

            i = string.find(format, "Audio CD")

            if i != -1:
                rw.setFormat("Audio Book")

            i = string.find(format, "MP3 CD")

            if i != -1:
                rw.setFormat("Audio Book")

            i = string.find(format, "Audio Cassette")

            if i != -1:
                rw.setFormat("Audio Book")

            i = string.find(format, "CD-ROM")

            if i != -1:
                rw.setFormat("CD-ROM")

            i = string.find(format, "DVD-ROM")

            if i != -1:
                rw.setFormat("DVD-ROM")

            i = string.find(format, "Digital")

            if i != -1:
                rw.setFormat("eBook")

            i = string.find(format, "Unknown Binding")

            if i != -1:
                rw.setFormat("Unknown Binding")


    # Find Pages
    i = string.find(source, "noOfPagesSprite")

    if i != -1:
        pages = searchForPlus(source, "noOfPagesSprite")
        pages = searchForPlus(pages, "<span")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)
    else:
        tag = ">Product Details<"
        i = string.find(source, tag)

        if i == -1:
            tag = ">Product details<"
            i = string.find(source, tag)

        if i != -1:
            pages = searchForPlus(source, tag)
            i = string.find(pages, " pages</li>")

            if i != -1:
                pages = stripText(pages[i-10:])

                i = string.find(pages, " pages")

                if i != -1:
                    pages = stripText(pages[0:i])

                while string.find(pages, ">") != -1:
                    pages = searchForPlus(pages, ">")

                rw.setPages(stripText(pages))


    # Find Publisher/Date
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.rfind(publisher, "(")

        if i != -1:
            relDate = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            
            i = string.rfind(relDate, ")")

            if i != -1:
                relDate = stripText(relDate[0:i])
            
            rw.setReleaseDate(relDate)

        i = string.rfind(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        publisher =  string.replace(publisher, "\303\245", "\345")

        rw.setPublisher(publisher)


    # Find Series
    i = string.find(source, ">Series:<")

    if i != -1:
        series = searchForPlus(source, ">Series:<")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])

        i = string.find(series, ", Book")

        if i != -1:
            seriesNumber = stripText(series[i+6:])
            series = stripText(series[0:i])
            rw.setSeriesNumber(seriesNumber)

        i = string.find(series, "(Book")

        if i != -1:
            seriesNumber = stripText(series[i+5:])
            series = stripText(series[0:i])

            i = string.find(seriesNumber, ")")
            seriesNumber = stripText(seriesNumber[0:i])
            rw.setSeriesNumber(seriesNumber)

        rw.setSeries(series)


    # Find Language
    i = string.find(source, ">Language:<")

    if i != -1:
        language = searchForPlus(source, ">Language:<")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        rw.setLanguage(language[0:i])


    # Find ISBN
    i = string.find(source, "<b>ISBN-13:<")

    if i != -1:
        isbn = searchForPlus(source, "<b>ISBN-13:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        rw.setISBN(isbn[0:i])


    # Find ASIN
    i = string.find(source, ">ASIN:<")

    if i != -1:
        asin = searchForPlus(source, ">ASIN:<")
        asin = searchForPlus(asin, ">")
        i = string.find(asin, "<")
        rw.setASIN(asin[0:i])
    else:
        i = string.find(source, "b>ISBN-10:<")

        if i != -1:
            asin = searchForPlus(source, "b>ISBN-10:<")
            asin = searchForPlus(asin, ">")
            i = string.find(asin, "<")
            rw.setASIN(asin[0:i])


    # Find Dimensions
    i = string.find(source, "Product Dimensions:")

    if i != -1:
        dimensions = searchForPlus(source, "Product Dimensions:")
        dimensions = searchForPlus(dimensions, ">")
        i = string.find(dimensions, "<")
        rw.setDimensions(dimensions[0:i])


    # Find Dimensions (Kindle file size)
    i = string.find(source, ">File Size:<")

    if i != -1:
        dimensions = searchForPlus(source, ">File Size:<")
        dimensions = searchForPlus(dimensions, ">")
        i = string.find(dimensions, "<")
        rw.setDimensions(dimensions[0:i])


    # Find Weight
    i = string.find(source, ">Shipping Weight:<")

    if i != -1:
        weight = searchForPlus(source, ">Shipping Weight:<")
        weight = searchForPlus(weight, ">")
        i = string.find(weight, "<")
        weight = stripText(weight[0:i])

        i = string.find(weight, "(")

        if i != -1:
            weight = stripText(weight[0:i])

        rw.setWeight(weight)


    # Find Sales Rank
    tag = "id=\"SalesRank\""

    if string.find(source, tag) != -1:
        rank = searchForPlus(source, tag)
        rank = searchForPlus(rank, "</b>")
        i = string.find(rank, "<")
        rank = stripText(rank[0:i])

        i = string.find(rank, "#")

        if i != -1:
            rank = stripText(rank[i+1:])

        i = string.find(rank, " ")

        if i != -1:
            rank = stripText(rank[0:i])

        rank =  string.replace(rank, ",", "")
        rank =  string.replace(rank, ".", "")
        rw.setSalesRank(rank)


    # Find Category
    tag = "Similar Items by Category<"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = ">Look for similar items by category<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        i = string.find(cats, "</li>")

        if i != -1:
            cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Books":
                continue

            if cat == "Kindle Store":
                continue

            if cat == "Kindle eBooks":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1

    if rw.getCategory1() == "":
        tag = "<li class=\"zg_hrsr_item\">"

        if string.find(source, tag) != -1:
            cats = searchForPlus(source, tag)
            i = string.find(cats, "</li>")
            cats = stripText(cats[0:i])

            ccount = 1

            while (searchFor(cats, "href=\"") != None):
                cats = searchForPlus(cats, "href=\"")
                cats = searchForPlus(cats, "\">")
                i = string.find(cats, "<")
                cat = stripText(cats[0:i])

                if cat == "Books":
                    continue

                if cat == "Kindle Store":
                    continue

                if cat == "Kindle eBooks":
                    continue

                if ccount == 1:
                    rw.setCategory1(cat)
                elif ccount == 2:
                    rw.setCategory2(cat)
                else:
                    rw.setCategory3(cat)
                    break

                ccount = ccount + 1





try:
    rw.setBookObject(Book)
    extract(source)

finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
