# amazon.it scraper
#
# Copyright  1999-2013 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 2")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("Italiano")
    vw.setCertification("NR")
    vw.setCurrencySymbol("")


    i = string.find(source, "sai-identify")

    if i != -1:
        source = searchForPlus(source, "sai-identify")
        i = string.find(source, "/ASIN/")
        source = source[i-50:]
        source = searchForPlus(source, "<a href=")
        i = string.find(source, ">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "id=\"result_0\"")

    if i != -1:
        source = searchForPlus(source, "id=\"result_0\"")
        source = searchForPlus(source, "<a href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "il ne peut pas tre vendu sur Amazon Marketplace")

    if (i != -1):
        # Not found
        return;


    # Find Format (DVD, VHS)
    i = string.find(source, ">Formato:")

    if i != -1:
      format = searchForPlus(source,">Formato:")
      format = searchForPlus(format,">")
      i = string.find(format, "<")
      format = stripText(format[0:i])
      vw.setFormat(format)
        
    
    # Find Image (first try)
    image = ""
    i = string.find(source, "var imageSrc")

    if i != -1:
        image = searchForPlus(source, "var imageSrc")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""

        vw.setImage1(image)

        image = searchForPlus(source, "var imageSrc")
        i = string.find(image, "[{\"large\":")

        if i != -1 and i < 250:
            image = searchForPlus(image, "[{\"large\":")
            image = searchForPlus(image, "\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "no-image")

            if i != -1:
                image = ""

            vw.setLargeImage1(image)


    # Find Title
    source = searchForPlus(source, "\"btAsinTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, "[")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)
 

    # Find List Price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"listprice\"")
        listprice = searchForPlus(listprice, "EUR ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])     
        vw.setListPrice(listprice)
 

    # Find Price
    i = string.find(source, "class=\"priceLarge\"")

    if i != -1:
        value = searchForPlus(source, "class=\"priceLarge\"")
        value = searchForPlus(value, "EUR ")
        i = string.find(value, "<")
        value = stripText(value[0:i])     

        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())
    

    # Find Actors
    tag = '>Attori'
    i = string.find(source, tag)

    if i != -1:
        actors = searchForPlus(source, tag)
        i = string.find(actors, "</li>")
        actors = stripText(actors[0:i] + ">, <")

        while (searchFor(actors, ", ") != None):
            i = string.find(actors, "<a href")

            if i != -1:
                actors = searchForPlus(actors, "<a href")
                actors = searchForPlus(actors, ">")
                i = string.find(actors, "<")
                actor = stripText(actors[0:i])

                i = string.find(actors, "(")

                if i != -1:
                    actor = stripText(actors[0:i])

                vw.setActor(actor)

            actors = searchForPlus(actors, ", ")

            
        source = searchForPlus(source, "</li>")


    # Find Director
    tag = ">Regista"
    i = string.find(source, tag)
    if i != -1:
        director = searchForPlus(source, tag)
        director = searchForPlus(director, "<a href")
        director = searchForPlus(director, ">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)

    
    #Find Region
    tag = ">Regione:<"
    i = string.find(source, tag)

    if i != -1:
        region = searchForPlus(source, tag)
        region = searchForPlus(region, ">")
        i = string.find(region, "</li>")
        region = stripText(region[0:i])

        i = string.find(region, "(")

        if i != -1:
            region = stripText(region[0:i])

        region = string.replace(region, "Regione", "Region")

        vw.setStudio(region)

    
    #Find Running time
    tag = ">Durata:<"
    i = string.find(source, tag)

    if i != -1:
        time = searchForPlus(source, tag)
        time = searchForPlus(time, ">")
        i = string.find(time, "</li>")
        time = stripText(time[0:i])

        i = string.find(time, " ")

        if i != -1:
            time = stripText(time[0:i])

        vw.setRunningTime(time)

    
    #Find Sound
    tag = ">Audio:<"
    i = string.find(source, tag)

    if i != -1:
        sound = searchForPlus(source, tag)
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "</li>")
        sound = stripText(sound[0:i])
        vw.setSound(sound)

    
    #Find Language
    tag = ">Lingua:<"
    i = string.find(source, tag)

    if i != -1:
        language = searchForPlus(source, tag)
        language = searchForPlus(language, ">")
        i = string.find(language, "</li>")
        language = stripText(language[0:i])
        vw.setLanguage(language)

    
    #Find Aspect ratio
    tag = ">Formato:<"
    i = string.find(source, tag)

    if i != -1:
        aspectRatio = searchForPlus(source, tag)
        aspectRatio = searchForPlus(aspectRatio, ">")
        i = string.find(aspectRatio, "</li>")
        aspectRatio = stripText(aspectRatio[0:i])

        i = string.find(source, "Schermo panoramico")

        if i != -1:
            vw.setAspectRatio("Widescreen")
        else:
            vw.setAspectRatio("Standard")

    tag = "Formato immagine:"
    i = string.find(source, tag)

    if i != -1:
        aspectRatio = searchForPlus(source, tag)
        aspectRatio = searchForPlus(aspectRatio, ">")
        i = string.find(aspectRatio, "</li>")
        aspectRatio = stripText(aspectRatio[0:i])
        vw.setAspectRatio("Widescreen " + aspectRatio)

    
    #Find Studio
    tag = ">Studio:<"
    i = string.find(source, tag)

    if i != -1:
        studio = searchForPlus(source, tag)
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "</li>")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)
    

    #Find Date
    tag = ">Data versione"
    i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, ">")
        i = string.find(date, "</li>")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)
           

    # Find Comments
    tag = "id=\"productDescription\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<div class=\"emptyClear\">")
        comments = comments[0:i]

        i = string.find(comments, "<div class=\"seeAll\">")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<style ")

        if i != -1:
            comments = comments[0:i]

        comments =  string.replace(comments, "&#xF2;", "")
        vw.setProductInfo(comments)


try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
