# Borders scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("1")
    vw.setCurrencySymbol("$")

    i = string.find(source, "class=\"book_summary\"")

    if i == -1:
        return

    # Find Image
    i = string.find(source, "class=\"book_thumbnail\"")

    if i != -1:
        image = searchForPlus(source, "class=\"book_thumbnail\"")
        image = searchForPlus(image, " src='")
        i = string.find(image, "'")
        image = stripText(image[0:i])
        i = string.find(image, "placeholder")

        if i == -1:
            vw.setImage1(image)


    # Find Title
    title = searchForPlus(source, "class=\"book_summary\"")
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Format
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        format = searchForPlus(source, "class=\"pages\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.rfind(format, ",")

        if i != -1:
            format = stripText(format[0:i])

        vw.setFormat(format)


    # Find Publisher & date
    i = string.find(source, "class=\"publisher")

    if i != -1:
        studio = searchForPlus(source, "class=\"publisher")
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "<br />")
        studio = stripText(studio[0:i])
        studio = string.replace(studio, "*", "")

        # Find Publication Date
        i = string.rfind(studio, "<br>")

        if i != -1:
            vw.setReleaseDate(stripText(studio[i+4:]))
            studio = stripText(studio[0:i])

        vw.setStudio(studio)


    # Find Price
    tag = "class=\"sale_price\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"list_price\""
        i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find List Price
    i = string.find(source, "class=\"list_price\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"list_price\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        vw.setListPrice(listprice)


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        vw.setUPC(stripText(upc[0:i]))


    # General attributes
    i = string.find(source, ">Format:")

    if i != -1:
        attrs = searchForPlus(source, ">Format:")
        i = string.find(attrs, "<br/>")
        attrs = stripText(attrs[0:i])

        # Find rating
        i = string.find(attrs, "Rated ")

        if i != -1:
            mpaa = searchForPlus(attrs, "Rated ")
            i = string.find(mpaa, " ")
            mpaa = stripText(mpaa[0:i])
            i = string.find(mpaa, ",")

            if i != -1:
                mpaa = stripText(mpaa[0:i])

            if mpaa == "NR":
                vw.setCertification("NR")
            else:
                vw.setCertification(mpaa + " (MPAA)")


        # Find Running time
        i = string.find(attrs, " minutes")

        if i != -1:
            running = stripText(attrs[i-7:])
            i = string.find(running, " ")
            running = stripText(running[i:])
            i = string.find(running, " ")
            vw.setRunningTime(stripText(running[0:i]))


        # Find Sound
        i = string.rfind(attrs, "Dolby")

        if i != -1:
            sound = stripText(attrs[i:])
            i = string.find(sound, ",")

            if i != -1:
                sound = stripText(sound[0:i])

            vw.setSound(sound)


        # Find Widescreen
        i = string.find(attrs, " WS")

        if i != -1:
            vw.setAspectRatio("Widescreen")
        else:
            vw.setAspectRatio("Standard")


    # Find Aspect Ratio
    i = string.find(source, ">Aspect Ratio:")

    if i != -1:
        aspect = searchForPlus(source, ">Aspect Ratio:")
        aspect = searchForPlus(aspect, ">")
        i = string.find(aspect, "<")
        aspect = stripText(aspect[0:i])

        if aspect == "1.33:1":
            aspect = "Standard"

        vw.setAspectRatio(aspect)


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"review_about\"")

    if i != -1:
        info = searchForPlus(source, "class=\"review_about\"")
        info = searchForPlus(info, "</div>")
        i = string.find(info, "</div>")
        info = stripText(info[0:i])

        while (searchFor(info, "align=\"justify\"") != None):
            info = searchForPlus(info, "align=\"justify\"")
            info = searchForPlus(info, ">")
            i = string.find(info, "</p>")
            comments = appendComment(comments, stripText(info[0:i]))

        vw.setProductInfo(comments)


    # Find Director
    i = string.find(source, ">Director:")

    if i != -1:
        director = searchForPlus(source, ">Director:")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        vw.setDirector(stripText(director[0:i]))


    # Find Producer
    i = string.find(source, ">Producer:")

    if i != -1:
        producer = searchForPlus(source, ">Producer:")
        producer = searchForPlus(producer, "\">")
        i = string.find(producer, "<")
        vw.setProducer(stripText(producer[0:i]))


    # Find Actors
    actorTag = ">Actors:"
    i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Featured:"
        i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Voice:"
        i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Actor:"
        i = string.find(source, actorTag)

    if i != -1:
        actors = searchForPlus(source, actorTag)
        i = string.find(actors, "<br/>")
        actors = " / "  + stripText(actors[0:i])

        while (searchFor(actors, "href=\"") != None):
            actors = searchForPlus(actors, "href=\"")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            vw.setActor(stripText(actors[0:i]))

    # Find Writer
    i = string.find(source, ">Story:")

    if i != -1:
        writer = searchForPlus(source, ">Story:")
        writer = searchForPlus(writer, "</b>")
        i = string.find(writer, "<")
        vw.setWriter(stripText(writer[0:i]))


    # Find Screenplay, will overwrite with screenwriter
    i = string.find(source, ">Screenplay:")

    if i != -1:
        screenwriter = searchForPlus(source, ">Screenplay:")
        screenwriter = searchForPlus(screenwriter, "</b>")
        i = string.find(screenwriter, "<")
        vw.setScreenwriter(stripText(screenwriter[0:i]))


    # Find Screenwriter
    i = string.find(source, ">Screen Writer:")

    if i != -1:
        screenwriter = searchForPlus(source, ">Screen Writer:")
        screenwriter = searchForPlus(screenwriter, "</b>")
        i = string.find(screenwriter, "<")
        vw.setScreenwriter(stripText(screenwriter[0:i]))
    else:
        i = string.find(source, ">Screenwriter:")

        if i != -1:
            screenwriter = searchForPlus(source, ">Screenwriter:")
            screenwriter = searchForPlus(screenwriter, "</b>")
            i = string.find(screenwriter, "<")
            vw.setScreenwriter(stripText(screenwriter[0:i]))


    # Find Author
    i = string.find(source, ">Book Author:")

    if i != -1:
        author = searchForPlus(source, "Book Author:")
        author = searchForPlus(author, "</b>")
        i = string.find(author, "<")
        vw.setAuthor(stripText(author[0:i]))


    # Find Director of photography
    i = string.find(source, ">Director of Photography:")

    if i != -1:
        photographer = searchForPlus(source, ">Director of Photography:")
        photographer = searchForPlus(photographer, "</b>")
        i = string.find(photographer, "<")
        vw.setPhotographer(stripText(photographer[0:i]))


    # Find Composer
    i = string.find(source, ">Music Contributor(s):")

    if i != -1:
        composer = searchForPlus(source, ">Music Contributor(s):")
        composer = searchForPlus(composer, "</b>")
        i = string.find(composer, "<")
        vw.setComposer(stripText(composer[0:i]))


    # Find Composer
    i = string.find(source, ">Music Score Composer")

    if i != -1:
        composer = searchForPlus(source, ">Music Score Composer")
        composer = searchForPlus(composer, "\">")
        i = string.find(composer, "<")
        vw.setComposer(stripText(composer[0:i]))


    # Find Editor
    i = string.find(source, ">Editor:")

    if i != -1:
        editor = searchForPlus(source, ">Editor:")
        editor = searchForPlus(editor, "</b>")
        i = string.find(editor, "<")
        vw.setEditor(stripText(editor[0:i]))


    #Find Category
    i = string.find(source, ">Shelf Location:<")

    if i != -1:
        category = searchForPlus(source, ">Shelf Location:<")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])

        i = string.find(category, ", ")

        if i != -1:
            category = stripText(category[0:i])

        vw.setCategory1(category)





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
