# CD Universe video scraper
#
# Copyright  1999-2007 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setPlace("US")
    vw.setCurrencySymbol("$")


    # Find List price
    i = string.find(source, ">List Price")

    if (i != -1):
        listprice = searchForPlus(source, ">List Price")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        vw.setListPrice(listprice)


    # Find Ranking
    i = string.find(source, ">All Time Product Rank")

    if (i != -1):
        usedinfo = searchForPlus(source, ">All Time Product Rank")
        usedinfo = searchForPlus(usedinfo, "<td>")
        i = string.find(usedinfo, "<")
        salesrank = stripText(usedinfo[0:i])
        vw.setSalesRank(salesrank)



    # Find Image
    tag = "itemprop=\"image\""
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, "itemprop=\"image\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image-avail")

        if i == -1:
            vw.setImage1(image)

    i = string.find(source, ">Large Front<")

    if i != -1:
        images = stripText(source[i-150:])
        images = searchForPlus(images, "href=\"")
        i = string.find(images, "\"")
        images = "http://www.cduniverse.com" + stripText(images[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        images = http.getContents(images)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(images)
        t2.close()

        images = searchForPlus(images, "id=\"impc3\"")
        images = searchForPlus(images, "<img src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])
        vw.setLargeImage1(image)


    # Find Title
    i = string.find(source, "itemprop=\"name\"")

    if i != -1:
        title = searchForPlus(source, "itemprop=\"name\"")
        title = searchForPlus(title, "\">")
        i = string.find(title, "<")
        title = stripText(title[0:i])

        if title.endswith(" DVD") == 1:
            title = stripText(title[0: len(title)-4])
            vw.setFormat("DVD")

        if title.endswith(" Blu-ray") == 1:
            title = stripText(title[0: len(title)-8])
            vw.setFormat("Blu-ray")

        vw.setTitle(title)


    # Find Price
    i = string.find(source, "itemprop=\"offerDetails\"")

    if i != -1:
        value = searchFor(source, "itemprop=\"offerDetails\"")
        value = searchForPlus(value, "itemprop=\"price\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        vw.setItemValue(value)
        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find keywords
    keywords = ""
    i = string.find(source, ">Category")

    if i != -1:
        temp = searchForPlus(source, ">Category")
        i = string.find(temp, "</tr>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, " href") != None):
            temp = searchForPlus(temp, " href")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")

            if keywords == "":
                keywords = stripText(temp[0:i])
                vw.setCategory1(keywords)
            else:
                keywords = keywords + ", " + stripText(temp[0:i])

        vw.setKeywords(keywords)


    # Find Studio
    i = string.find(source, ">Studio <")

    if i != -1:
        studio = searchForPlus(source, ">Studio <")
        studio = searchForPlus(studio, "\">")
        i = string.find(studio, "<")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Copyright date
    i = string.find(source, ">Orig Year")

    if i != -1:
        copyDate = searchForPlus(source, ">Orig Year")
        copyDate = searchForPlus(copyDate, "<td>")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        vw.setCopyrightDate(copyDate)


    # Find Release date
    i = string.find(source, ">Release Date")

    if i != -1:
        date = searchForPlus(source, ">Release Date")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Rating
    i = string.find(source, ">Rating")

    if i != -1:
        mpaa = searchForPlus(source, ">Rating")
        mpaa = searchForPlus(mpaa, "<td>")
        i = string.find(mpaa, "</td>")
        mpaa = stripText(mpaa[0:i])
        vw.setCertification(mpaa)


    # Find Running time
    i = string.find(source, ">Running Time")

    if i != -1:
        running = searchForPlus(source, ">Running Time")
        running = searchForPlus(running, "<td>")
        i = string.find(running, "<")
        running = stripText(running[0:i])
        vw.setRunningTime(running)


    # Find Attributes
    attrs = ""

    i = string.find(source, ">Additional Info")

    if i != -1:
        tempData = searchForPlus(source, ">Additional Info")
        tempData = searchForPlus(tempData, "<td>")
        i = string.find(tempData, "</td>")
        attrs = attrs + " " + stripText(tempData[0:i])

    i = string.find(source, ">Movie Details")

    if i != -1:
        tempData = searchForPlus(source, ">Movie Details")
        tempData = searchForPlus(tempData, "<td>")
        i = string.find(tempData, "</td>")
        attrs = attrs + " " + stripText(tempData[0:i])


    # Find Widescreen
    i = string.find(attrs, "Widescreen")

    if i != -1:
        vw.setAspectRatio("widescreen")


    # Find Closed Captions
    i = string.find(attrs, "Closed Captioned")

    if i != -1:
        vw.setClosedCaptioned("true")


    # Find Color
    i = string.find(attrs, "Color")

    if i != -1:
        vw.setColor("Color")


    # Find Actors
    i = string.find(source, ">Starring")

    if i != -1:
        tempData = searchForPlus(source, ">Starring")
        i = string.find(tempData, "</tr>")
        actors = stripText(tempData[0:i])

        while (searchFor(actors, "href") != None):
            i = string.find(actors, "href")

            if i != -1:
                actors = searchForPlus(actors, "href")
                actors = searchForPlus(actors, ">")
                i = string.find(actors, "<")
                actor = stripText(actors[0:i])
                vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Director")

    if i != -1:
        tempData = searchForPlus(source, ">Director")
        tempData = searchForPlus(tempData, " href")
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        director = stripText(tempData[0:i])
        vw.setDirector(director)


    # Find Composer
    tag = ">Composer"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Music"
        i = string.find(source, tag)

    if i != -1:
        tempData = searchForPlus(source, tag)
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        composer = stripText(tempData[0:i])
        vw.setComposer(composer)


    # Find Photographer
    i = string.find(source, ">Director of Photography")

    if i != -1:
        tempData = searchForPlus(source, ">Director of Photography")
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        photographer = stripText(tempData[0:i])
        vw.setPhotographer(photographer)


    # Find Screenwriter
    tag = ">Screenwriter"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Screenplay"
        i = string.find(source, tag)

    if i != -1:
        tempData = searchForPlus(source, tag)
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        screenwriter = stripText(tempData[0:i])
        vw.setScreenwriter(screenwriter)


    # Find Editor
    tag = ">Editor"
    i = string.find(source, tag)

    if i != -1:
        tempData = searchForPlus(source, tag)
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        editor = stripText(tempData[0:i])
        vw.setEditor(editor)


    # Find Author
    tag = ">Story"
    i = string.find(source, tag)

    if i != -1:
        tempData = searchForPlus(source, tag)
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        author = stripText(tempData[0:i])
        vw.setAuthor(author)


    # Find Writer
    tag = ">Source Writer"
    i = string.find(source, tag)

    if i != -1:
        tempData = searchForPlus(source, tag)
        tempData = searchForPlus(tempData, "\">")
        i = string.find(tempData, "<")
        writer = stripText(tempData[0:i])
        setWriter(writer)


    # Find Comments (Review)
    i = string.find(source, "itemprop=\"description\"")

    if i != -1:
        comments = searchForPlus(source, "itemprop=\"description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<form ")

        if i != -1:
            comments = stripText(comments[0:i])

        vw.setProductInfo(comments)


    # Find user rating
    i = string.find(source, ">Average Rating:")

    if i != -1:
        temp = searchForPlus(source, ">Average Rating:")
        temp = searchForPlus(temp, ">")
        i = string.find(temp, "out")
        rating = stripText(temp[0:i])








try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
