# Tower records video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")

    #Check for not found
    i = string.find(source, "is not a valid Tower Records product number.")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    # Find List price
    i = string.find(source, "List Price:")

    if (i != -1):
        listprice = searchForPlus(source, "List Price:")
        listprice = searchForPlus(listprice, "\">")
        i = string.find(listprice, "<")
        vw.setListPrice(stripText(listprice[0:i]))


    # Find Image
    i = string.find(source, "<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\" style=\"width:100%\">")

    if i != -1:
        source = stripText(source[i:])
        source = searchForPlus(source, "src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "777777777")

        if i == -1:
            vw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"product_header\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if (i != -1):
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Actors
    i = string.find(source, "<h2>")

    if i != -1 and i < 200:
        source = searchForPlus(source, "<h2>")
        i = string.find(source, "</h2>")
        actors = stripText(source[0:i])

        while (searchFor(actors, "(") != None):
            i = string.find(actors, "(")
            actor = stripText(actors[0:i])
            i = string.find(actors, "\">")

            if i != -1:
                actor = stripText(actor[i+2:])

            actors = searchForPlus(actors, "(")

            if actors.startswith("director") == 1:
                vw.setDirector(actor)
            else:
                vw.setActor(actor)

            actors = stripText(searchForPlus(actors, ")"))

            if actors.startswith(",") == 1:
                actors = stripText(searchForPlus(actors, ","))

            if actors.startswith("and") == 1:
                actors = stripText(searchForPlus(actors, "and"))


    # Find Price
    i = string.find(source, ">Current Price:<")

    if i != -1:
        value = searchForPlus(source, ">Current Price:<")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Category
    i = string.find(source, ">Category:")

    if i != -1:
        category = searchForPlus(source, ">Category:")
        category = searchForPlus(category, "?div_id")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        vw.setCategory1(category)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        source = searchForPlus(source, ">Format:<")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        format = stripText(source[0:i])
        vw.setFormat(format)


    # Find Region
    i = string.find(source, ">Region:<")

    if i != -1:
        region = searchForPlus(source, ">Region:<")
        region = searchForPlus(region, ">")
        i = string.find(region, "(")
        region = stripText(region[0:i])
        vw.setRegion(region)


    # Find Release date
    i = string.find(source, ">Release Date:")

    if (i != -1):
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Copyright date
    copyDate = ""
    i = string.find(source, ">Original Release:")

    if i != -1:
        source = searchForPlus(source, ">Original Release:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        copyDate = stripText(source[0:i])
        vw.setCopyrightDate(copyDate)
    else:
        i = string.find(source, ">Theatrical Release:")

        if i != -1:
            copyDate = searchForPlus(source, ">Theatrical Release:")
            copyDate = searchForPlus(copyDate, ">")
            i = string.find(copyDate, "<")
            copyDate = stripText(copyDate[0:i])
            vw.setCopyrightDate(copyDate)


    # Find UPC
    i = string.find(source, ">UPC/EAN:")

    if i != -1:
        upc = searchForPlus(source, ">UPC/EAN:")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)


    # Find Studio
    i = string.find(source, ">Studio:</")

    if i != -1:
        studio = searchForPlus(source, ">Studio:</")
        studio = searchForPlus(studio, "\">")
        i = string.find(studio, "<")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Comments
    comments = ""
    i = string.find(source, "<h2>Review</h2>")

    if i != -1:
        source = searchForPlus(source, "<h2>Review</h2>")
        source = searchForPlus(source, "class=\"content\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        comments = "Review" + stripText(source[0:i])

    i = string.find(source, "<h2>Release Note")

    if i != -1:
        source = searchForPlus(source, "<h2>Release Note")
        source = searchForPlus(source, "class=\"content\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        comments = appendComment(comments, "Release Note" + stripText(source[0:i]))

    vw.setProductInfo(comments)






try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
